from summer.templates.RoleDetail import RoleDetail
from summer.templates.RoleList import RoleList
from summer.templates.UserDetail import UserDetail
from summer.templates.UserList import UserList
from summer.views.user import show_list as user_list, user_info, save_user, update_user
from summer.views.role import show_list as role_list, role_info, save_role, update_role

__author__ = 'tanshu'


class Router():
    def __init__(self):
        self.user_list_form = None
        self.user_detail_form = None
        self.role_list_form = None
        self.role_detail_form = None

    def show_users(self):
        users = user_list()
        if self.user_list_form is None:
            self.user_list_form = UserList(self, users)
            self.user_list_form.destroyed.connect(self.user_list_form_destroyed)
        self.user_list_form.show()

    def user_list_form_destroyed(self):
        self.user_list_form = None

    def show_user(self, id=None):
        user = user_info(id)
        if self.user_detail_form is None:
            self.user_detail_form = UserDetail(self, user)
            self.user_detail_form.destroyed.connect(self.user_detail_form_destroyed)
        self.user_detail_form.show()

    def user_detail_form_destroyed(self):
        self.user_detail_form = None
        if self.user_list_form is not None:
            self.user_list_form.update_data(user_list())

    def save_user(self, user):
        if 'UserID' not in user:
            save_user(user)
        else:
            update_user(user)


    def show_roles(self):
        roles = role_list()
        if self.role_list_form is None:
            self.role_list_form = RoleList(self, roles)
            self.role_list_form.destroyed.connect(self.role_list_form_destroyed)
        self.role_list_form.show()

    def role_list_form_destroyed(self):
        self.role_list_form = None

    def show_role(self, id=None):
        role = role_info(id)
        if self.role_detail_form is None:
            self.role_detail_form = RoleDetail(self, role)
            self.role_detail_form.destroyed.connect(self.role_detail_form_destroyed)
        self.role_detail_form.show()

    def role_detail_form_destroyed(self):
        self.role_detail_form = None
        if self.role_list_form is not None:
            self.role_list_form.update_data(role_list())

    def save_role(self, role):
        if 'RoleID' not in role:
            save_role(role)
        else:
            update_role(role)
